﻿# Install-Module -Name MicrosoftTeams #include if needed
# Install-Module -Name AzureADPreview #Include if needed


$UserCredential = Get-Credential
$Session = New-PSSession -ConfigurationName Microsoft.Exchange -ConnectionUri https://outlook.office365.com/powershell-liveid/ -Credential $UserCredential -Authentication Basic -AllowRedirection
Import-PSSession $Session
Connect-AzureAD -Credential $UserCredential
Connect-MicrosoftTeams # -Credential $UserCredential


$Policy = Get-AzureADDirectorySettingTemplate | ? {$_.DisplayName -eq "Group.Unified"}
$Settings = $Policy.CreateDirectorySetting()
New-AzureADDirectorySetting -DirectorySetting $Settings 
$Settings = Get-AzureADDirectorySetting | ? {$_.DisplayName -eq "Group.Unified"}
$Settings[“PrefixSuffixNamingRequirement”] = “Innofactor-[CountryOrRegion]-[Office]-[GroupName]"
$Settings[“CustomBlockedWordsList”] = (Get-Content c:\WorkFolder\blacklist.txt).ToString() 
Set-AzureADDirectorySetting -Id $Settings.Id -DirectorySetting $Settings


#Validates the change / current config with policy, standards and blocked words
$Setting = Get-AzureADDirectorySetting -Id (Get-AzureADDirectorySetting | where -Property DisplayName -Value "Group.Unified" -EQ).id
$Setting.Values 


# Identify existing policy
$Policy = Get-AzureADDirectorySetting | ? {$_.DisplayName -eq "Group.Unified"}
$NamingPolicy = $Policy["PrefixSuffixNamingRequirement"]
If (!($NamingPolicy))
   { Write-Host "No naming policy defined..."
     # EXIT 
     }
   Else
   { Write-Host ""
     Write-Host "Office 365 Groups naming policy is" $NamingPolicy }



# Remove-AzureADDirectorySetting -Id (Get-AzureADDirectorySetting | where -Property DisplayName -Value "Group.Unified" -EQ).id